<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <title>OpenID4VP</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-T3c6CoIi6uLrA9TneNEoa7RxnatzjcDSCmG1MXxSR1GAsXEV/Dwwykc2MPK8M2HN" crossorigin="anonymous">
    <style>
        body {
            height: 100%;
            margin: 0;
            display: flex;
            align-items: flex-start;
            justify-content: center;
            /*background: linear-gradient(to right, #e0e0e0 30%, #ccc 70%);*/
            /*background: #e0e0e0;*/
            background-image: url("/assets/images/bg3.JPG");
            background-size: cover;
            background-position: center;
            background-repeat: no-repeat;
            padding-top: 50px;
            font-family: 'Montserrat', sans-serif;
        }
        h4, h5, h6 {
            font-stretch: expanded;
            font-family: 'Montserrat', sans-serif;
            font-weight: 300;
        }
        .card {
            width: 80rem;
            background-color: white;
            box-shadow: 0 4px 8px rgba(0,0,0,0.1);
            border-radius: 8px;
        }

        .btn-primary, .btn-primary:hover, .btn-primary:active, .btn-primary:visited {
            background-color: #ff6f3c !important;
            border-color: #ff6f3c;
        }

    </style>
</head>

<body>
    <div class="card mt-2" style="width: 32rem;">

        <div class="card-header">
            <h4>Scan QR Code</h4>
        </div>

        <div class="card-body m-lg-3">
            <div class="container my-3 text-center">
                <div class="row my-3">
                    <div class="col-md-10 offset-md-1">
                        <img th:src="@{'data:image/png;base64,' + ${qrCodeImage}}" class="rounded" style="max-width: 50%"/>
                    </div>
                </div>

                <div class="row my-3 col-12">
                    <div class="col-md-10 offset-md-1 col-12">
                        <input type="text" th:value="${qrCodeText}" id="qrCodeTextId" readonly class="form-control col-12 text-bg-light" aria-label="Default" >
                    </div>
                </div>

                <div class="row justify-content-center">
                    <div class="col-6">
                        <button type="button" class="btn btn-primary w-100" onClick="copyToClipboard()">Copy QR Code</button>
                    </div>
                    <div class="col-6">
                        <button type="button" class="btn btn-secondary w-100" onClick="redirectToWallet()">Wallet</button>
                    </div>

                </div>
            </div>
        </div>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-C6RzsynM9kWDrMNeT87bh95OGNyZPhcTNXj1NW7RuBCsyN/o0jlpcV8Qyq46cDfL" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.8/dist/umd/popper.min.js" integrity="sha384-I7E8VVD/ismYTF4hNIPjVp/Zjvgyol6VFvRkX/vR+Vc4jQkC+hVqc2pM8ODewa9r" crossorigin="anonymous"></script>

    <script th:inline="javascript">
        function copyToClipboard(){
            let copyText = document.getElementById("qrCodeTextId");
            copyText.select();
            copyText.setSelectionRange(0, 99999);
            document.execCommand("copy");
        }

        const walletUrl = [[${walletRedirectUrl}]];

        function redirectToWallet(){
             window.location.href = walletUrl;
        }

        const sessionId = [[${sessionId}]];
        let pollingIntervalId;
        async function pollVPAuthenticationStatus(){
            try{
                // console.log(`Verifying the status of the session with id: ${sessionId}`);
                const response = await fetch(`/openid4vp/session/${sessionId}`);
                const data = await response.text();
                console.log(`Result from the server for session ${sessionId} is ${data}`);
                if(data === 'true'){
                    console.log("The session has been authenticated");
                    clearInterval(pollingIntervalId);
                    window.location.href = `/openid4vp/continue/${sessionId}`
                } else {
                    console.log("The session is still pending");
                }
            } catch (e) {
                console.log(`Get an error when fetching session [${sessionId}] status: ${e}`);
            }
        }

        window.onload= function (){
            pollingIntervalId = setInterval(pollVPAuthenticationStatus, 6000);
        }

    </script>

</body>
</html>